#!/usr/bin/python

import string
import re
import sys
import math
import random

import solarfnc

# ------------------------------------------------------------------------------
write_top_sysfile = solarfnc.write_top_sysfile
write_bottom_sysfile = solarfnc.write_bottom_sysfile
write_top_quadfile = solarfnc.write_top_quadfile
write_bottom_quadfile = solarfnc.write_bottom_quadfile
create_solar_system = solarfnc.create_solar_system
create_nebulae = solarfnc.create_nebulae
create_protostar = solarfnc.create_protostar
create_asteroid_belt = solarfnc.create_asteroid_belt
create_infestation = solarfnc.create_infestation
quadrant_systems = solarfnc.quadrant_systems
quadrant_special_locations = solarfnc.quadrant_special_locations
# ------------------------------------------------------------------------------

outfile = open('../SystemTypes.txt', 'w')

write_top_sysfile(outfile)

# ------------------------------------------------------------------------------
# Small Solar Systems with extra asteroids
# ------------------------------------------------------------------------------
sysnum = 0

num_stars = 1
num_asteroids = 4
num_storms = 1

# [ring, type (rock, ice, gas), moons]

pnum = []

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [6, 'Gas Giant', 1],
          [7, 'Ice', 0],
          [8, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [6, 'Gas Giant', 1],
          [7, 'Gas Giant', 0],
          [8, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Gas Giant', 0],
          [6, 'Gas Giant', 1],
          [7, 'Ice', 0],
          [8, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 1],
          [6, 'Rock', 0],
          [6, 'Gas Giant', 1],
          [7, 'Ice', 0],
          [8, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [6, 'Gas Giant', 1],
          [7, 'Ice', 0],
          [7, 'Ice', 1],
          [8, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [6, 'Gas Giant', 0],
          [6, 'Gas Giant', 1],
          [7, 'Ice', 0],
          [8, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

# ------------------------------------------------------------------------------
# Larger Solar Systems with less asteroids
# ------------------------------------------------------------------------------
num_stars = 1
num_asteroids = 3
num_storms = 1

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [5, 'Gas Giant', 0],
          [6, 'Gas Giant', 0],
          [6, 'Gas Giant', 1],
          [7, 'Ice', 0],
          [8, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [6, 'Rock', 0],
          [7, 'Gas Giant', 0],
          [7, 'Gas Giant', 1],
          [8, 'Ice', 0],
          [8, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [6, 'Gas Giant', 0],
          [6, 'Gas Giant', 1],
          [7, 'Ice', 0],
          [7, 'Ice', 0],
          [8, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [5, 'Gas Giant', 1],
          [6, 'Gas Giant', 0],
          [7, 'Gas Giant', 1],
          [7, 'Ice', 0],
          [8, 'Ice', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 1],
          [6, 'Rock', 0],
          [6, 'Gas Giant', 0],
          [7, 'Gas Giant', 2],
          [7, 'Gas Giant', 1],
          [8, 'Ice', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [6, 'Gas Giant', 0],
          [6, 'Gas Giant', 1],
          [7, 'Gas Giant', 0],
          [7, 'Gas Giant', 1],
          [8, 'Ice', 0],
          [9, 'Ice', 1]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [5, 'Rock', 0],
          [6, 'Gas Giant', 0],
          [6, 'Gas Giant', 2],
          [7, 'Gas Giant', 1],
          [8, 'Ice', 0],
          [8, 'Ice', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [5, 'Gas Giant', 1],
          [6, 'Gas Giant', 2],
          [6, 'Gas Giant', 0],
          [7, 'Ice', 0],
          [8, 'Ice', 0],
          [9, 'Ice', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [5, 'Rock', 0],
          [6, 'Rock', 0],
          [7, 'Gas Giant', 1],
          [7, 'Gas Giant', 0],
          [8, 'Gas Giant', 1],
          [9, 'Ice', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [5, 'Rock', 0],
          [6, 'Gas Giant', 0],
          [7, 'Gas Giant', 1],
          [7, 'Gas Giant', 0],
          [8, 'Gas Giant', 1],
          [9, 'Ice', 0],
          [10, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [6, 'Rock', 1],
          [6, 'Rock', 0],
          [7, 'Gas Giant', 0],
          [8, 'Gas Giant', 1],
          [8, 'Gas Giant', 0],
          [9, 'Ice', 0],
          [10, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)

sysnum += 1
num_storms = random.randint(1, 3)

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [6, 'Rock', 0],
          [6, 'Gas Giant', 0],
          [7, 'Gas Giant', 1],
          [7, 'Gas Giant', 0],
          [8, 'Ice', 0],
          [9, 'Ice', 0],
          [10, 'Ice', 1],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, sysnum, planets, num_stars, num_asteroids, num_storms)


# ------------------------------------------------------------------------------
# Binary Solar Systems
# ------------------------------------------------------------------------------
binary_num = 0

num_stars = 2
num_asteroids = 4
num_storms = 1

binary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [6, 'Rock', 0],
          [7, 'Gas Giant', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, binary_num, planets, num_stars, num_asteroids, num_storms)

binary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, binary_num, planets, num_stars, num_asteroids, num_storms)

num_asteroids = 3

binary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [6, 'Rock', 0],
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, binary_num, planets, num_stars, num_asteroids, num_storms)

binary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [6, 'Rock', 0],
          [7, 'Gas Giant', 0],
          [9, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, binary_num, planets, num_stars, num_asteroids, num_storms)

binary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [6, 'Rock', 0],
          [7, 'Gas Giant', 0],
          [8, 'Gas Giant', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, binary_num, planets, num_stars, num_asteroids, num_storms)

binary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [6, 'Rock', 0],
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [8, 'Gas Giant', 0],
          [9, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, binary_num, planets, num_stars, num_asteroids, num_storms)

binary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [6, 'Rock', 0],
          [7, 'Rock', 0],
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [8, 'Gas Giant', 0],
          [9, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, binary_num, planets, num_stars, num_asteroids, num_storms)

binary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [6, 'Rock', 0],
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [9, 'Gas Giant', 0],
          [9, 'Gas Giant', 0],
          [10, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, binary_num, planets, num_stars, num_asteroids, num_storms)

binary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [6, 'Rock', 0],
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [8, 'Gas Giant', 0],
          [9, 'Ice', 0],
          [10, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, binary_num, planets, num_stars, num_asteroids, num_storms)

binary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [6, 'Rock', 0],
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [8, 'Gas Giant', 0],
          [9, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, binary_num, planets, num_stars, num_asteroids, num_storms)

# ------------------------------------------------------------------------------
# Trinary Solar Systems
# ------------------------------------------------------------------------------
trinary_num = 0

num_stars = 3
num_asteroids = 3
num_storms = 1

trinary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [7, 'Rock', 0],
          [8, 'Rock', 0],
          [9, 'Gas Giant', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, trinary_num, planets, num_stars, num_asteroids, num_storms)

trinary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [9, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, trinary_num, planets, num_stars, num_asteroids, num_storms)

trinary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [9, 'Gas Giant', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, trinary_num, planets, num_stars, num_asteroids, num_storms)

trinary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [7, 'Rock', 0],
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [9, 'Gas Giant', 0],
          [10, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, trinary_num, planets, num_stars, num_asteroids, num_storms)

trinary_num += 1
num_storms = random.randint(1, 3)

planets = [
          [7, 'Rock', 0],
          [8, 'Rock', 0],
          [9, 'Gas Giant', 0],
          [9, 'Gas Giant', 0],
          [10, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, trinary_num, planets, num_stars, num_asteroids, num_storms)

# ------------------------------------------------------------------------------
# Quaternary Solar Systems
# ------------------------------------------------------------------------------
quaternary_num = 0

num_stars = 4
num_asteroids = 3
num_storms = 1

quaternary_num += 1
num_storms = random.randint(2, 4)

planets = [
          [7, 'Rock', 0],
          [8, 'Rock', 0],
          [9, 'Gas Giant', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, quaternary_num, planets, num_stars, num_asteroids, num_storms)

quaternary_num += 1
num_storms = random.randint(2, 4)

planets = [
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [9, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, quaternary_num, planets, num_stars, num_asteroids, num_storms)

quaternary_num += 1
num_storms = random.randint(2, 4)

planets = [
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [9, 'Gas Giant', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, quaternary_num, planets, num_stars, num_asteroids, num_storms)

quaternary_num += 1
num_storms = random.randint(2, 4)

planets = [
          [7, 'Rock', 0],
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [9, 'Gas Giant', 0],
          [10, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, quaternary_num, planets, num_stars, num_asteroids, num_storms)

quaternary_num += 1
num_storms = random.randint(2, 4)

planets = [
          [7, 'Rock', 0],
          [8, 'Rock', 0],
          [9, 'Gas Giant', 0],
          [9, 'Gas Giant', 0],
          [10, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, quaternary_num, planets, num_stars, num_asteroids, num_storms)

# ------------------------------------------------------------------------------
# Quintuple Solar Systems
# ------------------------------------------------------------------------------
quintuple_num = 0

num_stars = 5
num_asteroids = 3
num_storms = 1

quintuple_num += 1
num_storms = random.randint(2, 4)

planets = [
          [7, 'Rock', 0],
          [8, 'Rock', 0],
          [9, 'Gas Giant', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, quintuple_num, planets, num_stars, num_asteroids, num_storms)

quintuple_num += 1
num_storms = random.randint(2, 4)

planets = [
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [9, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, quintuple_num, planets, num_stars, num_asteroids, num_storms)

quintuple_num += 1
num_storms = random.randint(2, 4)

planets = [
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [9, 'Gas Giant', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, quintuple_num, planets, num_stars, num_asteroids, num_storms)

quintuple_num += 1
num_storms = random.randint(2, 4)

planets = [
          [7, 'Rock', 0],
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [9, 'Gas Giant', 0],
          [10, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, quintuple_num, planets, num_stars, num_asteroids, num_storms)

quintuple_num += 1
num_storms = random.randint(2, 4)

planets = [
          [7, 'Rock', 0],
          [8, 'Rock', 0],
          [9, 'Gas Giant', 0],
          [9, 'Gas Giant', 0],
          [10, 'Ice', 0],
          [10, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, quintuple_num, planets, num_stars, num_asteroids, num_storms)

# ------------------------------------------------------------------------------
# Nebulae Systems
# ------------------------------------------------------------------------------
nebulae_num = 0

num_storms = 60

i = 0
while i < 20:
  nebulae_num += 1
  create_nebulae(outfile, nebulae_num, num_storms, i+1)
  i += 1

# ------------------------------------------------------------------------------
# Protostar Systems
# ------------------------------------------------------------------------------
protostar_num = 0

num_stars = 1
num_asteroids = 3

num_storms = 30

planets = [
          [7, 'Rock', 0],
          [8, 'Gas Giant', 0],
          [9, 'Ice', 0]
          ]
# Color Chart
# 1  - red
# 2  - burnt orange
# 3  - orange
# 4  - yellow
# 5  - yellow-green
# 6  - green
# 7  - cyan
# 8  - blue
# 9  - indigo
# 10 - purple
# 11 - white

red = 1
burnt_orange = 2
orange = 3
yellow = 4
yellow_green = 5
green = 6
cyan = 7
blue = 8
indigo = 9
purple = 10
white = 11

protostar_num += 1
pnum.append(len(planets))
create_protostar(outfile, protostar_num, planets, num_stars, num_asteroids, num_storms, red)

protostar_num += 1
pnum.append(len(planets))
create_protostar(outfile, protostar_num, planets, num_stars, num_asteroids, num_storms, orange)

protostar_num += 1
pnum.append(len(planets))
create_protostar(outfile, protostar_num, planets, num_stars, num_asteroids, num_storms, yellow)

protostar_num += 1
pnum.append(len(planets))
create_protostar(outfile, protostar_num, planets, num_stars, num_asteroids, num_storms, green)

protostar_num += 1
pnum.append(len(planets))
create_protostar(outfile, protostar_num, planets, num_stars, num_asteroids, num_storms, blue)

protostar_num += 1
pnum.append(len(planets))
create_protostar(outfile, protostar_num, planets, num_stars, num_asteroids, num_storms, white)

# ------------------------------------------------------------------------------
# Organic Infestation Systems
# ------------------------------------------------------------------------------
infestation_num = 0

num_stars = 1
num_asteroids = 3

num_storms = 30

planets = [
          [4, 'Rock', 0],
          [5, 'Rock', 0],
          [6, 'Gas Giant', 0],
          [7, 'Gas Giant', 0],
          [8, 'Ice', 0],
          [9, 'Ice', 0]
          ]

# Color Chart
# 1 - green
# 2 - orange
# 3 - yellow
# 4 - blue
# 5 - red
# 6 - white/grey

infestation_num += 1
pnum.append(len(planets))
create_infestation(outfile, infestation_num, planets, num_stars, num_asteroids, num_storms, 1)

infestation_num += 1
pnum.append(len(planets))
create_infestation(outfile, infestation_num, planets, num_stars, num_asteroids, num_storms, 1)

infestation_num += 1
pnum.append(len(planets))
create_infestation(outfile, infestation_num, planets, num_stars, num_asteroids, num_storms, 1)

infestation_num += 1
pnum.append(len(planets))
create_infestation(outfile, infestation_num, planets, num_stars, num_asteroids, num_storms, 1)

infestation_num += 1
pnum.append(len(planets))
create_infestation(outfile, infestation_num, planets, num_stars, num_asteroids, num_storms, 1)

# ------------------------------------------------------------------------------
# Red Giant Systems
# ------------------------------------------------------------------------------
rg_num = 0

num_stars = 'Red Giant'
num_asteroids = 2
num_storms = 2

rg_num += 1

planets = [
          [7, 'Rock', 0],
          [8, 'Gas Giant', 1],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, rg_num, planets, num_stars, num_asteroids, num_storms)

rg_num += 1

planets = [
          [6, 'Rock', 0],
          [6, 'Rock', 0],
          [7, 'Gas Giant', 1],
          [8, 'Gas Giant', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, rg_num, planets, num_stars, num_asteroids, num_storms)

rg_num += 1

planets = [
          [6, 'Rock', 0],
          [7, 'Gas Giant', 0],
          [8, 'Gas Giant', 1],
          [9, 'Ice', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, rg_num, planets, num_stars, num_asteroids, num_storms)

rg_num += 1

planets = [
          [6, 'Rock', 0],
          [6, 'Rock', 0],
          [7, 'Gas Giant', 1],
          [8, 'Ice', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, rg_num, planets, num_stars, num_asteroids, num_storms)

rg_num += 1

planets = [
          [6, 'Rock', 0],
          [6, 'Rock', 0],
          [7, 'Gas Giant', 1],
          [7, 'Gas Giant', 1],
          [8, 'Ice', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, rg_num, planets, num_stars, num_asteroids, num_storms)

# ------------------------------------------------------------------------------
# White Dwarf Systems
# ------------------------------------------------------------------------------
wd_num = 0

num_stars = 'White Dwarf'
num_asteroids = 2
num_storms = 1

wd_num += 1

planets = [
          [7, 'Rock', 0],
          [8, 'Gas Giant', 1],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, wd_num, planets, num_stars, num_asteroids, num_storms)

wd_num += 1

planets = [
          [6, 'Rock', 0],
          [6, 'Rock', 0],
          [7, 'Gas Giant', 1],
          [8, 'Gas Giant', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, wd_num, planets, num_stars, num_asteroids, num_storms)

wd_num += 1

planets = [
          [6, 'Rock', 0],
          [7, 'Gas Giant', 0],
          [8, 'Gas Giant', 1],
          [9, 'Ice', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, wd_num, planets, num_stars, num_asteroids, num_storms)

wd_num += 1

planets = [
          [6, 'Rock', 0],
          [6, 'Rock', 0],
          [7, 'Gas Giant', 1],
          [8, 'Ice', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, wd_num, planets, num_stars, num_asteroids, num_storms)

wd_num += 1

planets = [
          [6, 'Rock', 0],
          [6, 'Rock', 0],
          [7, 'Gas Giant', 1],
          [7, 'Gas Giant', 1],
          [8, 'Ice', 0],
          [9, 'Ice', 0]
          ]

pnum.append(len(planets))

create_solar_system(outfile, wd_num, planets, num_stars, num_asteroids, num_storms)

# ------------------------------------------------------------------------------
# Neutron Star Systems
# ------------------------------------------------------------------------------
neutron_num = 0

num_stars = 'Neutron'
num_asteroids = 4
num_storms = 3

neutron_num += 1

planets = []

pnum.append(len(planets))

create_solar_system(outfile, neutron_num, planets, num_stars, num_asteroids, num_storms)

neutron_num += 1

planets = []

pnum.append(len(planets))

create_solar_system(outfile, neutron_num, planets, num_stars, num_asteroids, num_storms)

neutron_num += 1

planets = []

pnum.append(len(planets))

create_solar_system(outfile, neutron_num, planets, num_stars, num_asteroids, num_storms)

neutron_num += 1

planets = []

pnum.append(len(planets))

create_solar_system(outfile, neutron_num, planets, num_stars, num_asteroids, num_storms)

neutron_num += 1

planets = []

pnum.append(len(planets))

create_solar_system(outfile, neutron_num, planets, num_stars, num_asteroids, num_storms)

# ------------------------------------------------------------------------------
# Rogue Gas Giant Systems
# ------------------------------------------------------------------------------
roguegg_num = 0

num_stars = 'Rogue Gas Giant'
num_asteroids = 0
num_storms = 2

roguegg_num += 1

planets = [
          [1, 'Gas Giant', 2]
          ]

pnum.append(len(planets))

create_solar_system(outfile, roguegg_num, planets, num_stars, num_asteroids, num_storms)

roguegg_num += 1

planets = [
          [1, 'Gas Giant', 3]
          ]

pnum.append(len(planets))

create_solar_system(outfile, roguegg_num, planets, num_stars, num_asteroids, num_storms)

roguegg_num += 1

planets = [
          [1, 'Gas Giant', 4]
          ]

pnum.append(len(planets))

create_solar_system(outfile, roguegg_num, planets, num_stars, num_asteroids, num_storms)

# ------------------------------------------------------------------------------
# Asteroid Belt Systems
# ------------------------------------------------------------------------------
asteroid_belt_num = 0

num_stars = 1
num_storms = 2

planets = [
          ]

asteroid_belt_num += 1

num_asteroids = 17
num_huge_asteroids = 0

pnum.append(len(planets))

create_asteroid_belt(outfile, asteroid_belt_num, planets, num_stars, num_asteroids, num_storms, num_huge_asteroids)

asteroid_belt_num += 1

num_asteroids = 18
num_huge_asteroids = 1

pnum.append(len(planets))

create_asteroid_belt(outfile, asteroid_belt_num, planets, num_stars, num_asteroids, num_storms, num_huge_asteroids)

asteroid_belt_num += 1

num_asteroids = 19
num_huge_asteroids = 2

pnum.append(len(planets))

create_asteroid_belt(outfile, asteroid_belt_num, planets, num_stars, num_asteroids, num_storms, num_huge_asteroids)

asteroid_belt_num += 1

num_asteroids = 20
num_huge_asteroids = 1

pnum.append(len(planets))

create_asteroid_belt(outfile, asteroid_belt_num, planets, num_stars, num_asteroids, num_storms, num_huge_asteroids)

asteroid_belt_num += 1

num_asteroids = 20
num_huge_asteroids = 2

pnum.append(len(planets))

create_asteroid_belt(outfile, asteroid_belt_num, planets, num_stars, num_asteroids, num_storms, num_huge_asteroids)

# ------------------------------------------------------------------------------
# End Solar System Definitions
# ------------------------------------------------------------------------------

write_bottom_sysfile(outfile)

outfile.close()

#print pnum

# ------------------------------------------------------------------------------
# Generate quadrant types
# ------------------------------------------------------------------------------
outfile = open('../QuadrantTypes.txt', 'w')

write_top_quadfile(outfile)

# Determines the system type chance values for the quadrant.
#
# chances array:
#   0 : expanse
#   1 : standard solar systems
#   2 : binary
#   3 : trinary
#   4 : quaternary
#   5 : quintuple
#   6 : nebulae
#   7 : black hole
#   8 : protostar
#   9 : red giant
#   10: white dwarf
#   11: neutron star
#   12: rogue gas giant
chances = [0, 560, 160, 40, 0, 0, 100, 20, 12, 30, 30, 20, 3]

blackhole_num = 10
counts = [0, sysnum, binary_num, trinary_num, quaternary_num, quintuple_num, nebulae_num, blackhole_num, protostar_num, rg_num, wd_num, neutron_num, roguegg_num, asteroid_belt_num]

#chances = [0, 80, 0, 0, 0, 0, 900, 0, 120, 0, 0, 0, 0]
#
## ------------------------------------------------------------------------------
#outfile.write('Name                      := Nebtacular\n')
#outfile.write('Description               := Test map with lots of nebulae and protostars.\n')
#outfile.write('Min Dist Between Systems  := 1\n')
#outfile.write('System Placement          := Random\n')
#outfile.write('Max Warp Points per Sys   := 5\n')
#outfile.write('Min Angle Between WP      := 60\n')
#outfile.write('Number of Locations       := 0\n')
#
#quadrant_systems (outfile, counts, pnum, chances, 1)
#outfile.write('\n')
## ------------------------------------------------------------------------------
#
#chances = [0, 560, 160, 40, 0, 0, 100, 20, 12, 30, 30, 20, 3]

# ------------------------------------------------------------------------------
outfile.write('Name                      := Mid-Life\n')
outfile.write('Description               := Standard middle age section of the galaxy.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')
outfile.write('Number of Locations       := 0\n')

quadrant_systems (outfile, counts, pnum, chances, 1)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Cluster\n')
outfile.write('Description               := A globular cluster section of the galaxy.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Clusters\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')
outfile.write('Number of Locations       := 0\n')

quadrant_systems (outfile, counts, pnum, chances, 1)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Galactic Edge\n')
outfile.write('Description               := The galactic edge where systems are spread evenly.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Diffuse\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')
outfile.write('Number of Locations       := 0\n')

quadrant_systems (outfile, counts, pnum, chances, 1)
outfile.write('\n')
# ------------------------------------------------------------------------------

outfile.write('Name                      := Spiral Arm\n')
outfile.write('Description               := Standard galaxy quadrant.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Spiral\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')
outfile.write('Number of Locations       := 0\n')

quadrant_systems (outfile, counts, pnum, chances, 1)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Threaded Spiral\n')
outfile.write('Description               := Similar to Spiral quadrants, except that the systems are connected in a threaded fashion.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Spiral\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 110\n')
outfile.write('Number of Locations       := 0\n')

quadrant_systems (outfile, counts, pnum, chances, 1)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Grid\n')
outfile.write('Description               := A section of the galaxy that is very grid-like in appearance.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Grid\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')
outfile.write('Number of Locations       := 0\n')

quadrant_systems (outfile, counts, pnum, chances, 1)
outfile.write('\n')

# ------------------------------------------------------------------------------
outfile.write('Name                      := Super Grid\n')
outfile.write('Description               := A gridded section of the galaxy with an unusual number of warp points.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Grid\n')
outfile.write('Max Warp Points per Sys   := 10\n')
outfile.write('Min Angle Between WP      := 30\n')
outfile.write('Number of Locations       := 0\n')

quadrant_systems (outfile, counts, pnum, chances, 1)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Maze\n')
outfile.write('Description               := Maze-like section of the galaxy.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Grid\n')
outfile.write('Max Warp Points per Sys   := 1\n')
outfile.write('Min Angle Between WP      := 360\n')
outfile.write('Number of Locations       := 0\n')

quadrant_systems (outfile, counts, pnum, chances, 1)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Psuedo-FTL\n')
outfile.write('Description               := Standard middle age section of the galaxy with an extreme amount of warp points.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 10\n')
outfile.write('Min Angle Between WP      := 10\n')
outfile.write('Number of Locations       := 0\n')

quadrant_systems (outfile, counts, pnum, chances, 1)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Spaghetti\n')
outfile.write('Description               := Spaghetti-like section of the galaxy in which warp points tend to form long strings of systems.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 3\n')
outfile.write('Min Angle Between WP      := 90\n')
outfile.write('Number of Locations       := 0\n')

quadrant_systems (outfile, counts, pnum, chances, 1)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Paradise\n')
outfile.write('Description               := Non-standard section of the galaxy with no "bad" systems. Designed to be AI-Friendly..\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')
outfile.write('Number of Locations       := 0\n')

chances = [0, 720, 160, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0]

quadrant_systems (outfile, counts, pnum, chances, 1)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Star Heavy\n')
outfile.write('Description               := Star-heavy section of the galaxy.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')
outfile.write('Number of Locations       := 0\n')

chances = [0, 260, 264, 132, 66, 38, 80, 20, 12, 40, 30, 30, 3]

quadrant_systems (outfile, counts, pnum, chances, 1)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Newborn\n')
outfile.write('Description               := Newly forming section of the galaxy dotted with nebulae and protostars.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')
outfile.write('Number of Locations       := 0\n')

chances = [0, 480, 160, 40, 0, 0, 120, 0, 120, 0, 0, 0, 3]

quadrant_systems (outfile, counts, pnum, chances, 2)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Old\n')
outfile.write('Description               := Old section of the galaxy dotted with nebulae and black holes.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')
outfile.write('Number of Locations       := 0\n')

chances = [0, 490, 120, 40, 20, 10, 120, 40, 0, 40, 40, 40, 6]

quadrant_systems (outfile, counts, pnum, chances, 2)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Ancient\n')
outfile.write('Description               := Ancient section of the galaxy mired with nebulae and black holes.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')
outfile.write('Number of Locations       := 0\n')

chances = [0, 400, 140, 40, 20, 10, 140, 60, 0, 50, 50, 50, 9]

quadrant_systems (outfile, counts, pnum, chances, 2)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Dying\n')
outfile.write('Description               := A truly ancient section of the galaxy in its last stages of life.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')
outfile.write('Number of Locations       := 0\n')

chances = [0, 320, 80, 40, 20, 10, 160, 150, 0, 50, 50, 80, 9]

quadrant_systems (outfile, counts, pnum, chances, 2)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Desert\n')
outfile.write('Description               := Broken section of the galaxy with vast expanses of barren systems, mired in destructive regions.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')
outfile.write('Number of Locations       := 0\n')

chances = [250, 300, 120, 30, 10, 5, 100, 70, 0, 30, 30, 20, 3]
desert_counts = counts
desert_counts[0] = 1

quadrant_systems (outfile, counts, pnum, chances, 2)
outfile.write('\n')
# ------------------------------------------------------------------------------

# Reset chance and count arrays for use with special quadrant shapes.
chances = [0, 560, 160, 40, 0, 0, 100, 20, 12, 30, 30, 20, 3]
counts = [0, sysnum, binary_num, trinary_num, quaternary_num, quintuple_num, nebulae_num, blackhole_num, protostar_num, rg_num, wd_num, neutron_num, roguegg_num, asteroid_belt_num]

# ------------------------------------------------------------------------------
outfile.write('Name                      := Ringed\n')
outfile.write('Description               := Ringed section of the galaxy.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 45\n')

loc_num = 104

quadrant_special_locations ('ring', loc_num, outfile, counts, pnum, chances, 1)

quadrant_systems (outfile, counts, pnum, chances, 2)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Wheel\n')
outfile.write('Description               := Section of the galaxy shaped like a large spoked wheel.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 4\n')
outfile.write('Min Angle Between WP      := 60\n')

loc_num = 104

quadrant_special_locations ('wheel', loc_num, outfile, counts, pnum, chances, 1)

quadrant_systems (outfile, counts, pnum, chances, 2)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Diamond\n')
outfile.write('Description               := Diamond-shaped section of the galaxy.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')

loc_num = 121

quadrant_special_locations ('diamond', loc_num, outfile, counts, pnum, chances, 1)

quadrant_systems (outfile, counts, pnum, chances, 2)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Logarithmic Spiral\n')
outfile.write('Description               := A logarithmic spiral shaped section of the galaxy.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 4\n')
outfile.write('Min Angle Between WP      := 60\n')

loc_num = 100

quadrant_special_locations ('spiral', loc_num, outfile, counts, pnum, chances, 1)

quadrant_systems (outfile, counts, pnum, chances, 2)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Shell Spiral\n')
outfile.write('Description               := A spiral shaped section of the galaxy that resembles a sea shell.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 5\n')
outfile.write('Min Angle Between WP      := 60\n')

loc_num = 100

quadrant_special_locations ('shell spiral', loc_num, outfile, counts, pnum, chances, 1)

quadrant_systems (outfile, counts, pnum, chances, 2)
outfile.write('\n')
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
outfile.write('Name                      := Flower Spiral\n')
outfile.write('Description               := A spiral shaped section of the galaxy that resembles a flower. Not recommended for smaller quadrants.\n')
outfile.write('Min Dist Between Systems  := 1\n')
outfile.write('System Placement          := Random\n')
outfile.write('Max Warp Points per Sys   := 3\n')
outfile.write('Min Angle Between WP      := 60\n')

loc_num = 100

quadrant_special_locations ('flower spiral', loc_num, outfile, counts, pnum, chances, 1)

quadrant_systems (outfile, counts, pnum, chances, 2)
outfile.write('\n')
# ------------------------------------------------------------------------------

write_bottom_quadfile(outfile)

outfile.close()

print 'Any planets generated   : ' + str(solarfnc.tot_any)
print 'Rock planets generated  : ' + str(solarfnc.tot_roc)
print 'Gas giants generated    : ' + str(solarfnc.tot_gas)
print 'Ice planets generated   : ' + str(solarfnc.tot_ice) + '\n'
print 'Moons generated         : ' + str(solarfnc.tot_mns) + '\n'
print 'Unknowns detected       : ' + str(solarfnc.tot_unk)
